<h1 align="center">
  eShopSync -Magento-2-Salesforce Connecter with REST API
  <br>
  <br>
</h1>
<p align="center" style="font-size: 1.2rem;">Built over Salesforce REST API</p>
 

> See
> [Webkul Store Applications](https://eshopsync.com/)

## Store Version:
- version 4.0

## Functionality supported 

> Export from Magento to Salesforce

|            |                      | Real time |        | Manual |        |
|------------|----------------------|:---------:|:------:|:------:|:------:|
| Magento    | Salesforce           |    Add    | Update |   Add  | Update |
| Contact Us | Lead                 |     Y     |    N   |        |        |
| Category   | Category             |     Y     |    Y   |    Y   |    Y   |
| Product    | Product              |     Y     |    Y   |    Y   |    Y   |
| Order      | Order                |     Y     |    Y   |    Y   |    Y   |
| Customer   | Account and contacts |     Y     |    Y   |    Y   |    Y   |	


---
## The problem

We required an application that allows import and export of data between Salesforce and Magento 2 using REST API.

## This solution

This is a software that uses Salesforce REST API to provide the desired functionality.

> NOTE: Currently whole project is under testing process. So please double check every feature and please let me know if there are any other imporvements required.

## Features
1. Connect to salesforce account using oAuth2. i.e, connecting by simply login to your salesforce org.
2. Export of categories and products.
3. Export of user and orders.
4. Contact Us export as lead
5. Configurations to select the desired objects and records over all synchronize data is available.
6. Token revoke on disconnecting connection.

## Installation Instructions for now
1. Make sure that folder SalesforceConnector is in expected path as app/code/Webkul/SalesforceConnector in extracted form
2. Go to your phpmyadmin select your database and then run a sql query as
  Delete from setup_module where module ='Webkul_SalesforceConnector';
3. run command php bin/magento setup:db-schema:upgrade
4. run command php bin/magento setup:upgrade
5. run command php bin/magento c:c

## Setup Instructions
1. Install eShopSync for magento package in your Salesforce, and follow the required setup procedure.
2. Install this extension in your magento -2  Site and actiavate it.
3. The installed plugin will be listed as 'Salesforce Connector' in magento2.
4. Go to configuration and login to desired Salesforce environment (This will build the connection).
5. After connection set up basic pre-requisites.

## Important configuration
1. For person and buissness org, change appropriate commenting in etc/config.xml
2. For Magento Enterprise edition, change 'mgedition' to 1 in etc/config.xml


## Commit version 3.0.1
1. Improved directory structure
2. Added upgardeschema file so that table can be installed while setup upgrade

## Commit version 3.0.2
1. git issues fixes

## Commit version 3.0.2
1. git issues fixes

## Commit version 3.0.3
1. Made Customer email clickable 
2. Fixed order sync issue reported at client end

## Commit version 3.0.4
1. git issues fixes

## Commit version 3.0.5
1. git issues fixes
2. BA-PA merged. Check etc/config.xml to switch

## Commit version 3.0.6 - 3.0.9
1. git issues fixes
 
## Commit version 3.1.0
1. git issues fixes

## Commit version 3.1.1
1. Magento Enterprise edition compatibility

## Commit version 3.1.3
Fix, Issue with order place when real time order sync enable

## Commit 961030b55251823be8c2dda44a64e744ae0bf8ed
1)Fixed All GIT issues.
New Feature:
a)Opportunity and Opportunity Product Syncing.
b)Searchable Dropdown for Record Type,Price Book,Document Folder,Guest Account , Salesforce Main Account
c)Account Duplicacy Removed
d)Sync Every Customer as a contact in a Main Account.

## Commit version 3.1.4
Fixed Git Issues
New Feature:
Field Mapping for User,Product and Order

## Commit version 3.1.5
Fixed Git issues

```
┌┐┌┐┌┬───┬──┐┌┐┌─┬┐─┌┬┐───
││││││┌──┤┌┐││││┌┤│─│││───
││││││└──┤└┘└┤└┘┘││─│││───
│└┘└┘│┌──┤┌─┐│┌┐│││─│││─┌┐
└┐┌┐┌┤└──┤└─┘│││└┤└─┘│└─┘│
─└┘└┘└───┴───┴┘└─┴───┴───┘

```
